program SelectChar;

uses
  Windows,  SysUtils;

{$R *.RES}

var
  Index : integer;
  AChar : Char;
  Param : string;
  Chr : integer;
  Time: TDateTime;
  IsACapital: boolean;

procedure WaitABit;
begin
  Time := Now;
  While Now - Time < 5e-7 do
  begin
  end;
end;

function GetKey(Const AChar: Char; Out IsCap: boolean): Char;
begin
  IsCap := True;
  case AChar of
    '!': result := '1';
    '@': result := '2';
    '#': result := '3';
    '$': result := '4';
    '%': result := '5';
    '^': result := '6';
    '&': result := '7';
    '*': result := '8';
    '(': result := '9';
    ')': result := '0';
    '_': result := '-';
    '+': result := '=';
    '{': result := '[';
    '}': result := ']';
    '|': result := '|';
    ':': result := ';';
    '"': result := '''';
    '<': result := ',';
    '>': result := '.';
    '?': result := '/';
    'a'..'z':
      begin
        result := LowerCase(AChar)[1];
        IsCap := False;
      end;
    'A'..'Z': result := AChar;
  else
    begin
      result := AChar;
      IsCap := False;
    end;
  end;
end;

procedure WriteKey(AChar: Char);
begin
  AChar := GetKey(AChar, IsACapital);
  if IsACapital then
  begin
    keybd_event(VK_SHIFT, 0, 0, 0);
    WaitABit;
  end;
  keybd_event(VkKeyScan(AChar), 0, 0, 0);
  WaitABit;
  keybd_event(VkKeyScan(AChar), 0, KEYEVENTF_KEYUP, 0);
  WaitABit;
  if IsACapital then
  begin
    keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
    WaitABit;
  end;
end;

begin
  if ParamCount > 0 then
  begin
    Time := Now;
    For Index := 1 to ParamCount do
    begin
      Param := ParamStr(Index);
      if Pos('CTRL-',UpperCase(Param))> 0 then
      begin
        AChar := ParamStr(Index)[Pos('CTRL-',UpperCase(Param)) + Length('CTRL-')];
        keybd_event( VK_CONTROL, 0, 0, 0 );
        WaitABit;
        keybd_event( Ord(AChar), 0, 0, 0 );
        WaitABit;
        keybd_event( Ord(AChar), 0, KEYEVENTF_KEYUP, 0 );
        WaitABit;
        keybd_event( VK_CONTROL, 0, KEYEVENTF_KEYUP, 0 );
        WaitABit;
      end
      else if Pos('ALT-',UpperCase(Param))> 0 then
      begin
        AChar := ParamStr(Index)[Pos('ALT-',UpperCase(Param)) + Length('ALT-')];
        keybd_event( VK_MENU,0, 0, 0); // ALT down
        WaitABit;
        keybd_event( Ord(AChar), 0, 0, 0 );
        WaitABit;
        keybd_event( Ord(AChar), 0, KEYEVENTF_KEYUP, 0 );
        WaitABit;
        keybd_event( VK_MENU,0, KEYEVENTF_KEYUP, 0 ); // Alt up
        WaitABit;
      end
      else if Pos('CHR-',UpperCase(Param))> 0 then
      begin
        Param := Copy(Param,Pos('CHR-',UpperCase(Param))
          + Length('CHR-'),Length(Param));
        Chr := StrToInt(Param);
        WriteKey(Char(Chr));
        {keybd_event( Chr, 0, 0, 0 );
        WaitABit;
        keybd_event( Chr, 0, KEYEVENTF_KEYUP, 0 );
        WaitABit;  }
      end
      else if Pos('VK-',UpperCase(Param))> 0 then
      begin
        Param := Copy(Param,Pos('VK-',UpperCase(Param))
          + Length('VK-'),Length(Param));
        Chr := StrToInt(Param);
        keybd_event( Chr, 0, 0, 0 );
        WaitABit;
        keybd_event( Chr, 0, KEYEVENTF_KEYUP, 0 );
        WaitABit;  
      end
      else
      begin
        AChar := Param[1];
        WriteKey(AChar);
      end;
    end;
  end
  else
  begin
    keybd_event( 13, 0, 0, 0 );
    WaitABit;
    keybd_event( 13, 0, KEYEVENTF_KEYUP, 0 );
    WaitABit;
  end;

end.
